clc
clear all
close all
t0 = 0; tf=200; N=1000; %case 3

time =linspace(t0,tf,N);

  y0  = [1500,2000,200,150,100,80,5,5,200];% initial condition for STATE SYSTEM
 

%%
%--- SOURCES OF CONSTANTS --
Constant=[0.8 1/18250 0.09 0.1 1/70 1/90 1/(60*365) 0.42 13/37500 1.7 0.7 1.12 100000 0.00013/365 0.75 0.8 0.08 35/1000 1 0.01 1/28 1/400 5822 0.89 5822.89 20 40 30 10];
eta     = Constant(1); % Vaccination rate
b       = Constant(2); % Natural birth rate
epsilon1= Constant(3); % Shading rate for helminth infected individuals
epsilon2= Constant(4); % Shading rate for co-infected individuals
gamma1  = Constant(5); % Loss of temporary immunity for helminth recovered individuals
gamma2  = Constant(6); % Loss of temporary immunity for Tb recovered individuals
mu      = Constant(7); % Natural death rate
beta1   = Constant(8); % Transmission rate for Mtb
mu1     = Constant(9); % Clearance rate of parasitic worms
sigma   = Constant(10); % Modifcation Parameter
varrho  = Constant(11); % Vaccine wane rate
g       = Constant(12); % Modifcation Parameter
K       = Constant(13); % Number of parasites in the environment
k       = Constant(14); % Progression to active TB
alpha1  = Constant(15); % drug efficacy use for Mtb infection 
alpha2  = Constant(16); % drug efficacy use for helminth infection 
d1      = Constant(17); % Mtb disease induced death rate
d2      = Constant(18); % Helminths disease induced death rate
beta2   = Constant(19); % Ingestion rate of parasitic worms
d3      = Constant(20); % Helminths -Mtb disease induced death rate
tau1    = Constant(21); % Natural recovery rate for helminth infected individuals
tau2    = Constant(22); % Natural recover rate for Mtb infected individuals
C1      = Constant(23); % weight
C2      = Constant(24); % weight
C3      = Constant(25); % weight
B1      = Constant(26); % weight
B2      = Constant(27); %weight
B3      = Constant(28); % weight
B4      = Constant(29); % weight







lf  = [0 0 0 0 0 0 0 0 0]; 
%% TEST SECTION
init =y0;
init2 =lf;
h = (tf-t0)/N; 
u = linspace(0,0,N+1);
u1=u'; u2=u'; u3=u'; u4=u';
U = [u1 u2 u3 u4];
%% IMPLIMENTATION OF THE ALGORITHM
%Test 1 stoping condition 1
delta = 0.001;
X=init;
i=0; %Initialize iteration counter
mm=size(X);
NumXX =10e10;
Xnew = rand(N+1,mm(2)).*(repmat(X,N+1,1));
DenXnew=norm(Xnew);
while  NumXX/DenXnew>delta
Xold =  Xnew;
oldu = U;
%FORWARD RUNGE KUTTA  FOR STATES
[Tx, X]=rk4foward(@stide,t0, tf,N, init,U,Constant);

% BACKWARD RUNGEKUTA FOR COSTATES
[Tp, P]=rk4back(@stide_costate,t0,tf,N,init2,U,X,Constant);

%UPDATE THE CONTROLS 
x = X(1,:); y = X(2,:); v = X(3,:); z = X(4,:); l = X(5,:); q = X(6,:); r = X(7,:); s = X(8,:); m = X(9,:);  
L1 = P(1,:); L2 = P(2,:); L3 = P(3,:); L4 = P(4,:); L5 = P(5,:); L6 = P(6,:); L7 = P(7,:); L8 = P(8,:); L9 = P(9,:); 
g1=x+y+v+z+l+q+r+s+m;
lambda1=beta1.*(z+sigma.*q)./(g1);
lambda2=beta2*m./(K+m);
%Case_1
%Combination of educational campaign and  treatment of Mtb individuals
% % Case1_0:u1\neq= 0, u2\neq= 0,u3\neq= 0, u4= 0,
%  u1 =max(0,min(1,eta*b*g1.*L2./B1));
%  u2 =max(0,min(1,alpha1.*z.*(L4-L7)./B2));
%  u3 =zeros(1,N+1); 
%  u4 =zeros(1,N+1); 
%Combination of MDA and  sanitation 
% % Case2_1:u1\neq= 0, u2\neq= 0,u3\neq= 0, u4= 0,
%  u1 =zeros(1,N+1);
%  u2 =zeros(1,N+1);
%  u3 =max(0,min(1,(alpha2.*l.*(L5-L8)+alpha2.*q.*(L6-L4))./B3)); 
%  u4 =max(0,min(1,(lambda2.*L5.*(x+y+r)+lambda2.*L6.*(v+z)-lambda2.*x.*L1-lambda2.*y.*L2-lambda2.*v.*L3-lambda2.*z.*L4)./B4));

%Combination of educational campaign and  sanitation
% % Case1_3:u1\neq= 0, u2\neq= 0,u3\neq= 0, u4= 0,
%  u1 =max(0,min(1,eta*b*g1.*L2./B1));
%  u2 =zeros(1,N+1);
%  u3 =zeros(1,N+1); 
%  u4 =max(0,min(1,(lambda2.*L5.*(x+y+r)+lambda2.*L6.*(v+z)-lambda2.*x.*L1-lambda2.*y.*L2-lambda2.*v.*L3-lambda2.*z.*L4)./B4));
%Combination of treatment of Mtb and  MDA
% % Case1_4:u1\neq= 0, u2\neq= 0,u3\neq= 0, u4= 0,
%  u1 =zeros(1,N+1);
%  u2 =max(0,min(1,alpha1.*z.*(L4-L7)./B2));
%  u3 =max(0,min(1,(alpha2.*l.*(L5-L8)+alpha2.*q.*(L6-L4))./B3)); 
%  u4 =zeros(1,N+1);
% Combination of all controls 
% Case1_5:u1\neq= 0, u2\neq= 0,u3\neq= 0, u4= 0,
     u1 =max(0,min(1,eta*b*g1.*L2./B1));
     u2 =max(0,min(1,alpha1.*z.*(L4-L7)./B2));
     u3 =max(0,min(1,(alpha2.*l.*(L5-L8)+alpha2.*q.*(L6-L4))./B3)); 
     u4 =max(0,min(1,(lambda2.*L5.*(x+y+r)+lambda2.*L6.*(v+z)-lambda2.*x.*L1-lambda2.*y.*L2-lambda2.*v.*L3-lambda2.*z.*L4)./B4));



Uu=[u1' u2' u3' u4'];
U = 0.5*Uu + 0.5*oldu; % Convex combination of the controls


Xnew =  X';
NumXX =abs(norm(Xnew-Xold));
DenXnew =norm(Xnew);
i=i+1 %Update iteration counter
end
%% PLOTING
X=X';
Tx =Tx';
XX=X(:,1); YY=X(:,2); VV=X(:,3); ZZ=X(:,4); LL=X(:,5); QQ=X(:,6); RR=X(:,7); SS=X(:,8); MM=X(:,9);

Up = [0 0 0 0];
[T,Y] = ode45(@stide,time,y0,[],Up,Constant);

J =sum((C1.*ZZ(end)+C2.*LL(end)+C3.*QQ(end))+((B1/2)*Uu(:,1).*Uu(:,1)+(B2/2)*Uu(:,2).*Uu(:,2)+(B3/2)*Uu(:,3).*Uu(:,3)+(B4/2)*Uu(:,4).*Uu(:,4))); %Change to the suitable objective function

 S=[Tx,X];
 
 save case5;
 save('case3State', 'S');
 save('case3Control', 'Uu');
save('Cost', 'J');

 figure(1)

 subplot(2,3,1)
 plot(Tx,X(:,2),'-b',T, Y(:,2),'--r','LineWidth',1.5);
 %ylim([0 700])
 ylabel('V(t)');
 xlabel('Time (days)');
 title('(a)')
legend('u_1 \neq   0, u_2 \neq  0 , u_3 = 0 , u_4 =  0 ','u_i = 0, i=1,2,3,4 ')
%  
subplot(2,3,2)
 plot(Tx,X(:,4),'-b',T, Y(:,4),'--r','LineWidth',1.5);
  %%ylim([0 700])
 ylabel('I_T(t)');
  xlabel('Time (days)'); 
   title('(b)')
legend('u_1 \neq   0, u_2 \neq  0 , u_3 = 0 , u_4 =  0 ','u_i = 0, i=1,2,3,4 ')

subplot(2,3,3)
 plot(Tx,X(:,5),'-b',T, Y(:,5),'--r','LineWidth',1.5);
 %ylim([0 600])
 ylabel('I_H(t)');
 xlabel('Time (days)');
  title('(c)')
legend('u_1 \neq   0, u_2 \neq  0 , u_3 = 0 , u_4 =  0 ','u_i = 0, i=1,2,3,4 ')

subplot(2,3,4)
 plot(Tx,X(:,6),'-b',T, Y(:,6),'--r','LineWidth',1.5);
 %ylim([250 800])
 ylabel('I_{HT}(t)');
 xlabel('Time (days)');
  title('(d)')
legend('u_1 \neq   0, u_2 \neq  0 , u_3 = 0 , u_4 =  0 ','u_i = 0, i=1,2,3,4 ')

subplot(2,3,5)
 plot(Tx,X(:,9),'-b',T, Y(:,9),'--r','LineWidth',1.5);
 %ylim([250 800])
 ylabel('M(t)');
 xlabel('Time (days)');
  title('(e)')
legend('u_1 \neq   0, u_2 \neq  0 , u_3 = 0 , u_4 =  0 ','u_i = 0, i=1,2,3,4 ')

subplot(2,3,6)
 %plot(Tx,Uu(:,1),'-b',Tx,Uu(:,2),'--r',Tx,Uu(:,3),'--k',Tx,Uu(:,4),'-c', Tx);
 plot(Tx,Uu(:,1),'-b',Tx,Uu(:,2),'--r',Tx,Uu(:,3),'--k',Tx,Uu(:,4),'--g','LineWidth',1.5); 
  ylim([0 1])
 ylabel('Control Profile');
 xlabel('Time (days)');
  title('(f)')
legend('u_1 \neq  0', 'u_2 \neq 0' , 'u_3 =  0' , 'u_4 =   0 ')
 
%  
% collect all the incidence terms in the ODE 
 X=XX'; % solution of the optimal control
 U =[0 0 0 0]; % when no control
[Tx,Y] = ode45(@stide,time,y0,[],U,Constant);
 Y=(Y);
 Inew=sum(Y(:,6))-sum(X(:,6)); % averted







