
function [t, w]=rk4back_edit(f,t0, tf, N, init2,U,YY,constant)
%function rk4back() approximates the solutions of systems of 
%differential equations
%with input ode function f and t in the interval [a; b] and the initial 
%conditions are in the m-dimensional vector alpha
%as with function rk4back(), the inputs are the endpoints a and b, the
%number of subdivisions N in the interval [a; b], and the initial
h = -(tf-t0)/N;     %the step size
t(N+1) = tf;
t(1)=0;
w(:,N+1) = init2;     %initial conditions
%keyboard
for i = N:-1:1
    uu = 0.5*(U(i+1,:)+U(i,:));
    yy = 0.5*(YY(:,i+1)+YY(:,i));
    
   k1 = h*f(t(i),w(:,i),uu,yy,constant);
   k2 = h*f(t(i)+h/2, w(:,i)+0.5*k1,uu,yy,constant);
   k3 = h*f(t(i)+h/2, w(:,i)+0.5*k2,uu,yy,constant ); 
   k4 = h*f(t(i)+h, w(:,i)+k3,U(i,:),YY(:,i),constant);
  if i>1
   w(:,i) = w(:,i+1) + (k1 + 2*k2 + 2*k3 + k4)/6;
   t(i) = tf + i*h; 
  else
   ww = w(:,i) + (k1 + 2*k2 + 2*k3 + k4)/6;
   tt = t(1);   
  end
end
w = [ww w];
t = [tt t];

