function ydot = stide(t,yy,U,Constant)
%This function solves MU infection  equations
x=yy(1); 
y=yy(2); 
v=yy(3); 
z=yy(4);
l=yy(5);
q=yy(6);
r=yy(7);
s=yy(8);
m=yy(9);

eta     = Constant(1); % Vaccination rate
b       = Constant(2); % Natural birth rate
epsilon1= Constant(3); % Shading rate for helminth infected individuals
epsilon2= Constant(4); % Shading rate for co-infected individuals
gamma1  = Constant(5); % Loss of temporary immunity for helminth recovered individuals
gamma2  = Constant(6); % Loss of temporary immunity for Tb recovered individuals
mu      = Constant(7); % Natural death rate
beta1   = Constant(8); % Transmission rate for Mtb
mu1     = Constant(9); % Clearance rate of parasitic worms
sigma   = Constant(10); % Modifcation Parameter
varrho  = Constant(11); % Vaccine wane rate
g       = Constant(12); % Modifcation Parameter
K       = Constant(13); % Number of parasites in the environment
k       = Constant(14); % Progression to active TB
alpha1  = Constant(15); % drug efficacy use for Mtb infection 
alpha2  = Constant(16); % drug efficacy use for helminth infection 
d1      = Constant(17); % Mtb disease induced death rate
d2      = Constant(18); % Helminths disease induced death rate
beta2   = Constant(19); % Ingestion rate of parasitic worms
d3      = Constant(20); % Helminths -Mtb disease induced death rate
tau1    = Constant(21); % Natural recovery rate for helminth infected individuals
tau2    = Constant(22); % Natural recover rate for Mtb infected individuals
C1      = Constant(23); % weight
C2      = Constant(24); % weight
C3      = Constant(25); % weight
B1      = Constant(26); % weight
B2      = Constant(27); %weight
B3      = Constant(28); % weight
B4      = Constant(29); % weight


g1=x+y+v+z+l+q+r+s; %Toatal population
lambda1=beta1.*(z+sigma.*q)./(g1); % Force of infection for Mtb
lambda2=beta2*m./(K+m);  % Force of infection for helminths

u1 = U(1); u2=U(2);u3=U(3);u4=U(4); 
%Model equations
ydot1=(1-eta)*b*g1+gamma1*s+gamma2*r-(mu+lambda1+(1-u4)*lambda2).*x; 
ydot2=eta*b*(1+u1)*g1-(mu+varrho*lambda1+(1-u4).*lambda2).*y;
ydot3=lambda1.*(x+varrho*y+s)-(mu+k+(1-u4)*lambda2)*v;
ydot4=k.*v+(tau1+alpha2*u3)*q-(mu+d1+tau2+(1-u4)*lambda2).*z-(tau2+alpha1*u2).*z;
ydot5=(1-u4).*lambda2.*(x+y+r)+tau2.*q-(g.*lambda1+mu+d2+epsilon1).*l-(tau1+alpha2*u3).*l;
ydot6=g.*lambda1.*l+(1-u4).*lambda2.*(v+z)-(mu+d3+tau2+epsilon2).*q-(tau1+alpha2*u3).*q;
ydot7=(tau2+alpha1*u2).*z-((1-u4).*lambda2+mu+gamma2).*r;
ydot8=(tau1+alpha2*u3).*l-(lambda1+mu+gamma1).*s;
ydot9=epsilon1.*l+epsilon2.*q-mu1.*m;
ydot  = [ydot1; ydot2; ydot3; ydot4; ydot5; ydot6; ydot7; ydot8; ydot9];


