function ydot = stide_costate(t,y,U,X,Constant)
%This function solves a MU infection on human type three equations
 L1=y(1);
 L2=y(2);
 L3=y(3);
 L4=y(4);
 L5=y(5);
 L6=y(6);
 L7=y(7);
 L8=y(8);
 L9=y(9);
 
 
eta     = Constant(1); % Vaccination rate
b       = Constant(2); % Natural birth rate
epsilon1= Constant(3); % Shading rate for helminth infected individuals
epsilon2= Constant(4); % Shading rate for co-infected individuals
gamma1  = Constant(5); % Loss of temporary immunity for helminth recovered individuals
gamma2  = Constant(6); % Loss of temporary immunity for Tb recovered individuals
mu      = Constant(7); % Natural death rate
beta1   = Constant(8); % Transmission rate for Mtb
mu1     = Constant(9); % Clearance rate of parasitic worms
sigma   = Constant(10); % Modifcation Parameter
varrho  = Constant(11); % Vaccine wane rate
g       = Constant(12); % Modifcation Parameter
K       = Constant(13); % Number of parasites in the environment
k       = Constant(14); % Progression to active TB
alpha1  = Constant(15); % drug efficacy use for Mtb infection 
alpha2  = Constant(16); % drug efficacy use for helminth infection 
d1      = Constant(17); % Mtb disease induced death rate
d2      = Constant(18); % Helminths disease induced death rate
beta2   = Constant(19); % Ingestion rate of parasitic worms
d3      = Constant(20); % Helminths -Mtb disease induced death rate
tau1    = Constant(21); % Natural recovery rate for helminth infected individuals
tau2    = Constant(22); % Natural recover rate for Mtb infected individuals
C1      = Constant(23); % weight
C2      = Constant(24); % weight
C3      = Constant(25); % weight
B1      = Constant(26); % weight
B2      = Constant(27); %weight
B3      = Constant(28); % weight
B4      = Constant(29); % weight


%list your suitable parameters
u1 = U(1); u2=U(2); u3=U(3); u4=U(4);
x = X(1,:);y = X(2,:);v = X(3,:);z = X(4,:);l = X(5,:); q = X(6,:);r = X(7,:);s = X(8,:); m = X(9,:);
g1=x+y+v+z+l+q+r+s; % Total human population
lambda1=beta1.*(z+sigma.*q)./(g1); % Force of infection for Mtb
lambda2=beta2*m./(K+m); % Force of infection for helminth
%Co-state equations
ydot1=-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(y.*lambda1.*(varrho*L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+lambda1.*(L1-L3)+(g.*l.*lambda1.*(L6-L5))./g1+(1-u4).*lambda2.*(L1-L5)+mu.*L1;% first ODE
ydot2=-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(y.*lambda1.*(varrho*L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+lambda1.*(L2-varrho.*L3)+(g.*l.*lambda1.*(L6-L5))./g1+(1-u4).*lambda2.*(L2-L5)+mu.*L2; % second ODE
ydot3=-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+(g.*l.*lambda1.*(L6-L5))./g1+(1-u4).*lambda2.*(L3-L6)+k.*(L3-L4)+mu.*L3;
ydot4=-C1-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+g*beta1.*s.*(L5-L6)./g1+(g.*l.*lambda1.*(L6-L5))./g1+(1-u4).*lambda2.*(L4-L6)+beta1.*(x.*L1+y.*L2+z.*L8)./g1+(tau2+alpha1*u2).*(L4-L8)+(mu+d1).*L4;
ydot5=-C2-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+g.*lambda1.*(L5-L6)+(g.*l.*lambda1.*(L6-L5))./g1+(tau1+alpha2*u3).*(L5-L8)+(mu+d2+epsilon1).*L5-epsilon1.*L9;
ydot6=-C3-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+sigma.*g*beta1.*s.*(L5-L6)+(g.*l.*lambda1.*(L6-L5))./g1-sigma.*beta1.*(x+varrho.*y+s)./g1+beta1.*sigma.*(x.*L1+varrho.*y.*L2+s.*L8)./g1-tau2.*L5+(tau1+alpha2.*u3).*(L6-L4)+(mu+d3+tau2+epsilon2).*L6-epsilon2.*L9;
ydot7=-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+(1-u4).*lambda2.*(L7-L5)+(g.*l.*lambda1.*(L6-L5))./g1+gamma2.*(L7-L1)+mu.*L7;
ydot8=-(1-eta)*b.*L1-eta*b*(1+u1).*L2+(x.*lambda1.*(L3-L1))./g1+(varrho.*y.*lambda1.*(L3-L2))./g1+(s.*lambda1.*(L3-L8))./g1+lambda1.*(L8-L1)+(g.*l.*lambda1.*(L6-L5))./g1+gamma1.*(L8-L1)+mu.*L8;
ydot9=((1-u4).*lambda2.*x.*(L5-L1))./(K+m)+((1-u4).*lambda2.*y.*(L5-L2))./(K+m)+((1-u4).*lambda2.*r.*(L5-L7))./(K+m)+((1-u4).*lambda2.*v.*(L6-L3))./(K+m)+((1-u4).*lambda2.*z.*(L6-L4))./(K+m)+(1-u4).*beta2.*(x.*L1+y.*L2+v.*L3+z.*L4+r.*L7)./(K+m)-(1-u4).*beta2.*((x+y+r).*L5+(v+z).*L6)./(K+m)+mu1.*L9;
ydot  = [ydot1; ydot2; ydot3; ydot4; ydot5; ydot6; ydot7; ydot8; ydot9;];
%%************************************************************
